import java.awt.*;

public class DrawingGasolineTanker {
    protected EntityGasolineTanker GasolineTanker;
    public EntityGasolineTanker getGasolineTanker(){
        return GasolineTanker;
    }
    protected IDrawningObjectWheels Wheels;
    private CountWheels _wheels;
    protected int _startPosX;
    protected int _startPosY;
    private Integer _pictureWidth = null;
    private Integer _pictureHeight = null;
    private int _gasolineTankerWidth = 160;
    private int _gasolineTankerHeight = 70;

    public DrawingGasolineTanker(int speed, float weight, Color bodyColor, int wheelsForm)
    {
        GasolineTanker = new EntityGasolineTanker(speed, weight, bodyColor);
        Wheels= GetFormOfWheels(wheelsForm);
        Wheels.SetCountWheels((int)(2 + Math.random() + Math.random()*2));
    }
    public DrawingGasolineTanker(int speed, float weight, Color bodyColor, IDrawningObjectWheels wheelsForm)
    {
        GasolineTanker = new EntityGasolineTanker(speed, weight, bodyColor);
        Wheels= wheelsForm;
    }
    public DrawingGasolineTanker(int speed, float weight,int countwheel, Color bodyColor)
    {
        GasolineTanker = new EntityGasolineTanker(speed, weight, bodyColor);
        Wheels= GetFormOfWheels((int)(2 + Math.random() + Math.random()*2));
        Wheels.SetCountWheels(countwheel);
    }
    public DrawingGasolineTanker(EntityGasolineTanker gasolineTanker,IDrawningObjectWheels wheels)
    {
        GasolineTanker = gasolineTanker;
        Wheels = wheels;
    }
    public void SetWheels(IDrawningObjectWheels wheels){
        Wheels = wheels;
    }

    public void SetBodyColor(Color color){
        GasolineTanker= new EntityGasolineTanker(GasolineTanker.getSpeed(), GasolineTanker.getWeight(), color);
    }

    public IDrawningObjectWheels GetFormOfWheels(int FormOfWheel){
        OrnamentForm temp = null;
        for (OrnamentForm form:OrnamentForm.values()) {
            if(form.Value==FormOfWheel){
                temp = form;
                break;
            }
        }
        if(temp==null)
            return null;
        switch (temp){
            case NoneOrnament:
                return new DrawingWheels(_wheels);
            case GrayOrnament:
                return new DrawingOrnamentWheelsFirst(_wheels);
            case RedOrnament:
                return new DrawingOrnamentWheelsSecond(_wheels);
        }
        return null;
    }

    protected DrawingGasolineTanker(int speed, float weight, Color bodyColor,int gasolineTankerWidth, int gasolineTankerHeight)
    {
        GasolineTanker = new EntityGasolineTanker(speed, weight, bodyColor);
        Wheels= new DrawingWheels(_wheels);
        Wheels.SetCountWheels((int)(2 + Math.random() + Math.random()*2));
        _gasolineTankerWidth=gasolineTankerWidth;
        _pictureHeight=gasolineTankerHeight;
    }

    public void SetPosition(int x, int y, int width, int height)
    {
        if (x >= 0 && x+_gasolineTankerWidth <= width && y >= 0 && y+_gasolineTankerHeight <= height)
        {
            _startPosX = x;
            _startPosY = y;
            _pictureWidth = width;
            _pictureHeight = height;
        }
        else return;
    }

    public void MoveTransport(Direction direction)
    {
        if (_pictureWidth == null || _pictureHeight == null)
        {
            return;
        }
        switch (direction)
        {
            case Right:
                if (_startPosX + _gasolineTankerWidth + GasolineTanker.Step < _pictureWidth)
                {
                    _startPosX+=GasolineTanker.Step;
                }
                break;

            case Left:
                if (_startPosX- GasolineTanker.Step >= 0)
                {
                    _startPosX -= GasolineTanker.Step;
                }
                break;

            case Up:
                if (_startPosY - GasolineTanker.Step >= 0)
                {
                    _startPosY -= GasolineTanker.Step;
                }
                break;

            case Down:
                if (_startPosY + _gasolineTankerHeight + GasolineTanker.Step < _pictureHeight)
                {
                    _startPosY += GasolineTanker.Step;
                }
                break;
        }
    }

    public void DrawTransport(Graphics g)
    {
        if (_startPosX < 0 || _startPosY < 0 || _pictureHeight== null || _pictureWidth== null)
        {
            return;
        }

        Graphics2D g2 = (Graphics2D) g;

        g2.setColor(Color.BLACK);
        g2.drawOval(_startPosX + 130, _startPosY + 35, 20, 20);
        g2.fillOval(_startPosX + 130, _startPosY + 35, 20, 20);
        Wheels.DrawWheels(g2, _startPosX, _startPosY);

        g2.setColor(Color.yellow);
        g2.drawOval(_startPosX + 150, _startPosY + 30, 10, 10);
        g2.fillOval(_startPosX + 150, _startPosY + 30, 10, 10);

        g2.setColor(Color.RED);
        g2.drawOval(_startPosX+5, _startPosY + 35, 10, 10);
        g2.fillOval(_startPosX+5, _startPosY + 35, 10, 10);

        g2.setColor(GasolineTanker.getBodyColor());
        g2.drawRect(_startPosX + 115, _startPosY+5, 40, 40);
        g2.fillRect(_startPosX + 115, _startPosY+5, 40, 40);
        g2.drawRect(_startPosX + 10, _startPosY + 35, 140, 10);
        g2.fillRect(_startPosX + 10, _startPosY + 35, 140, 10);

        Color lightBlue = new Color(82, 186, 255);
        g2.setColor(lightBlue);
        g2.drawRect(_startPosX + 120, _startPosY + 10, 25, 25);
        g2.fillRect(_startPosX + 120, _startPosY + 10, 25, 25);
    }

    public void ChangeBorders(int width,int height)
    {
        _pictureWidth = width;
        _pictureHeight = height;
        if (_pictureWidth<=_gasolineTankerWidth||_pictureHeight<=_gasolineTankerHeight)
        {
            _pictureWidth = null;
            _pictureHeight = null;
            return;
        }
        if (_startPosX + _gasolineTankerWidth > _pictureWidth)
        {
            _startPosX = _pictureWidth - _gasolineTankerWidth;
        }
        if (_startPosY + _gasolineTankerHeight > _pictureHeight)
        {
            _startPosY = _pictureHeight - _gasolineTankerHeight;
        }
    }
    public float[] GetCurrentPosition() {
        float[] dim = new float[4];
        dim[0] = _startPosX;
        dim[1] =_startPosY;
        dim[2] = _startPosX + _gasolineTankerWidth;
        dim[3] = _startPosY + _gasolineTankerHeight;
        return dim;
    }
}
