import java.awt.*;

public class DrawingImprovedGasolineTanker extends DrawingGasolineTanker {

    public DrawingImprovedGasolineTanker(int speed, float weight, Color bodyColor, Color dopColor, boolean bodyKit, boolean antena,int wheelForm) {
        super(speed, weight, bodyColor, 160, 70);
        GasolineTanker=new EntityImprovedGasolineTanker(speed,weight,bodyColor,dopColor,bodyKit,antena);
        Wheels= GetFormOfWheels(wheelForm);
        Wheels.SetCountWheels((int)(2 + Math.random() + Math.random()*2));
    }
    public DrawingImprovedGasolineTanker(int speed, float weight,int countwheels, Color bodyColor, Color dopColor, boolean bodyKit,boolean antena) {
        super(speed, weight, bodyColor, 120, 50);
        GasolineTanker=new EntityImprovedGasolineTanker(speed,weight,bodyColor,dopColor,bodyKit,antena);
        Wheels.SetCountWheels(countwheels);
    }
    public DrawingImprovedGasolineTanker(int speed, float weight, Color bodyColor, Color dopColor, boolean bodyKit, boolean antena,IDrawningObjectWheels wheelForm) {
        super(speed, weight, bodyColor, 160, 70);
        GasolineTanker=new EntityImprovedGasolineTanker(speed,weight,bodyColor,dopColor,bodyKit,antena);
        Wheels= wheelForm;
    }
    public DrawingImprovedGasolineTanker(EntityGasolineTanker gasolineTanker,IDrawningObjectWheels wheels) {
        super(gasolineTanker,wheels);
        GasolineTanker=gasolineTanker;
    }
    @Override
    public void SetBodyColor(Color color){
        var gasolineTanker=(EntityImprovedGasolineTanker) GasolineTanker;
        GasolineTanker=new EntityImprovedGasolineTanker(gasolineTanker.getSpeed(),gasolineTanker.getWeight(),color,gasolineTanker.GetDopColor(), gasolineTanker.GetBodyKit(), gasolineTanker.GetAntena());
    }
    public void SetDopColor(Color color){
        var gasolineTanker=(EntityImprovedGasolineTanker) GasolineTanker;
        GasolineTanker=new EntityImprovedGasolineTanker(gasolineTanker.getSpeed(),gasolineTanker.getWeight(),gasolineTanker.getBodyColor(),color, gasolineTanker.GetBodyKit(), gasolineTanker.GetAntena());
    }
    @Override
    public void DrawTransport(Graphics g) {

        if (! (GasolineTanker instanceof EntityImprovedGasolineTanker))
        {
            return;
        }

        EntityImprovedGasolineTanker improvedGasolineTanker  = (EntityImprovedGasolineTanker)GasolineTanker;
        Graphics2D g2 = (Graphics2D) g;

        int [] x1 ={_startPosX+25,_startPosX+65,_startPosX+75,_startPosX+25,_startPosX+25};
        int [] y1 ={_startPosY,_startPosY,_startPosY+5,_startPosY+5,_startPosY};
        int [] x2 ={_startPosX+25,_startPosX+75,_startPosX+65,_startPosX+25,_startPosX+25};
        int [] y2 ={_startPosY+45,_startPosY+45,_startPosY+50,_startPosY+50,_startPosY+45};

        if (improvedGasolineTanker.BodyKit)
        {
            g2.setColor(improvedGasolineTanker.GetDopColor());
            g2.drawRect(_startPosX + 25, _startPosY + 5, 100, 35);
            g2.fillRect(_startPosX + 25, _startPosY + 5, 100, 35);

        }

        _startPosX += 10;
        _startPosY += 5;
        super.DrawTransport(g);
        _startPosX -= 10;
        _startPosY -= 5;

        if (improvedGasolineTanker.Antena)
        {
            g2.setColor(Color.RED);
            g2.drawRect(_startPosX + 130, _startPosY + 5, 10, 5);
            g2.fillRect(_startPosX + 130, _startPosY + 5, 10, 5);

        }
    }
}
