import java.awt.*;
import java.awt.image.BufferedImage;
import java.util.ArrayDeque;

public class MapWithSetGasolineTankerGeneric <T extends IDrawingObject,U extends AbstractMap>{
    private final int _pictureWidth;
    private final int _pictureHeight;
    private final int _placeSizeWidth = 210;
    private final int _placeSizeHeight = 90;
    private final SetGasolineTankerGeneric<T> _setGasolineTanker;
    private final ArrayDeque<T> DeletedGasolineTanker;
    private final U _map;

    public MapWithSetGasolineTankerGeneric(int picWidth,int picHeight, U map)
    {
        int width = picWidth / _placeSizeWidth;
        int height = picHeight/_placeSizeHeight;
        _setGasolineTanker = new SetGasolineTankerGeneric<>(width * height);
        _pictureWidth = picWidth;
        _pictureHeight = picHeight;
        _map = map;
        DeletedGasolineTanker = new ArrayDeque<>();
    }

    public int plus(T gasolineTanker)
    {
        return _setGasolineTanker.Insert(gasolineTanker);
    }

    public T minus(int position)
    {
        T gasolineTanker=_setGasolineTanker.Remove(position);
        DeletedGasolineTanker.push(gasolineTanker);
        return gasolineTanker;
    }

    public Image ShowSet()
    {
        BufferedImage bmp = new BufferedImage(_pictureWidth, _pictureWidth,BufferedImage.TYPE_INT_ARGB);
        Graphics gr = bmp.getGraphics();
        DrawBackground(gr);
        DrawGasolineTanker(gr);
        return bmp;
    }

    public Image ShowOnMap()
    {
        Shaking();
        for (IDrawingObject gasolineTanker : _setGasolineTanker)
        {
            return _map.CreateMap(_pictureWidth, _pictureHeight, gasolineTanker);
        }
        return new BufferedImage(_pictureWidth, _pictureHeight,1);
    }

    public Image MoveObject(Direction direction)
    {
        if (_map != null)
        {
            return _map.MoveObject(direction);
        }
        return new BufferedImage(_pictureWidth, _pictureHeight,1);
    }

    public void Shaking()
    {
        int j = _setGasolineTanker.Count() - 1;
        for (int i = 0; i < _setGasolineTanker.Count(); i++)
        {
            if (_setGasolineTanker.Get(i) == null)
            {
                for (; j > i; j--)
                {
                    T gasolineTanker = _setGasolineTanker.Get(j);
                    if (gasolineTanker != null)
                    {
                        _setGasolineTanker.Insert(gasolineTanker, i);
                        _setGasolineTanker.Remove(j);
                        break;
                    }
                }
                if (j <= i)
                {
                    return;
                }
            }
        }
    }

    private void DrawBackground(Graphics gr)
    {
        Graphics2D g=(Graphics2D)gr;

        Color brush=Color.BLACK;
        Stroke penWide = new BasicStroke(5);
        Stroke penThin = new BasicStroke(1);

        for (int i = 0; i < _pictureWidth / _placeSizeWidth; i++)
        {
            for (int j = 0; j < _pictureHeight / _placeSizeHeight + 1; ++j)
            {
                g.setColor(brush);
                g.setStroke(penWide);
                g.drawLine(i * _placeSizeWidth + 10, j * _placeSizeHeight + 2, i * _placeSizeWidth + (int)(_placeSizeWidth * 0.8), j * _placeSizeHeight + 2);
                g.drawLine(i * _placeSizeWidth + (int)(_placeSizeWidth * 0.8), j * _placeSizeHeight + 2, i * _placeSizeWidth + (int)(_placeSizeWidth * 0.9) + 10, j * _placeSizeHeight + 2 + 20);
                g.drawLine(i * _placeSizeWidth + (int)(_placeSizeWidth * 0.9) + 10, j * _placeSizeHeight + 2 + 20, i * _placeSizeWidth + (int)(_placeSizeWidth * 0.9) + 10, j * _placeSizeHeight + 2 + 20);
                g.setStroke(penThin);
            }
        }
    }

    private void DrawGasolineTanker(Graphics gr)
    {
        int width = _pictureWidth / _placeSizeWidth;
        int height = _pictureHeight / _placeSizeHeight;

        for (int i = 0; i < _setGasolineTanker.Count(); i++)
        {
            if (_setGasolineTanker.Get(i) != null)
            {
                _setGasolineTanker.Get(i).SetObject(i % width * _placeSizeWidth, (height - 1 - i / width) * _placeSizeHeight, _pictureWidth, _pictureHeight);
                _setGasolineTanker.Get(i).DrawingObject(gr);
            }
        }
    }
    public T GetGasolineTankerArrayDeque(int i){
        return _setGasolineTanker.Get(i);
    }

    public T GetGasolineTankerInDeleted() {
        if(DeletedGasolineTanker.isEmpty())
            return null;
        return DeletedGasolineTanker.pop();
    }
}
